module dwt.internal.mozilla.nsIExternalHelperAppService;

import dwt.internal.mozilla.Common;
import dwt.internal.mozilla.nsID;
import dwt.internal.mozilla.nsISupports;
import dwt.internal.mozilla.nsICancelable;
import dwt.internal.mozilla.nsIURI; 
import dwt.internal.mozilla.nsIRequest;
import dwt.internal.mozilla.nsIStreamListener; 
import dwt.internal.mozilla.nsIFile; 
import dwt.internal.mozilla.nsIMIMEInfo; 
import dwt.internal.mozilla.nsIWebProgressListener2;
import dwt.internal.mozilla.nsIInterfaceRequestor;
import dwt.internal.mozilla.nsStringAPI;

import dwt.internal.mozilla.prtime;

/******************************************************************************

******************************************************************************/

const char[] NS_IEXTERNALHELPERAPPSERVICE_IID_STR = "0ea90cf3-2dd9-470f-8f76-f141743c5678";

const nsIID NS_IEXTERNALHELPERAPPSERVICE_IID= 
  {0x0ea90cf3, 0x2dd9, 0x470f, 
    [ 0x8f, 0x76, 0xf1, 0x41, 0x74, 0x3c, 0x56, 0x78 ]};

extern(System)

interface nsIExternalHelperAppService : nsISupports {

  static const char[] IID_STR = NS_IEXTERNALHELPERAPPSERVICE_IID_STR;
  static const nsIID IID = NS_IEXTERNALHELPERAPPSERVICE_IID;

  nsresult DoContent(nsACString * aMimeContentType, nsIRequest aRequest, nsIInterfaceRequestor aWindowContext, nsIStreamListener *_retval);
  nsresult ApplyDecodingForExtension(nsACString * aExtension, nsACString * aEncodingType, PRBool *_retval);

}

/******************************************************************************

******************************************************************************/

const char[] NS_PIEXTERNALAPPLAUNCHER_IID_STR = "d0b5d7d3-9565-403d-9fb5-e5089c4567c6";

const nsIID NS_PIEXTERNALAPPLAUNCHER_IID= 
  {0xd0b5d7d3, 0x9565, 0x403d, 
    [ 0x9f, 0xb5, 0xe5, 0x08, 0x9c, 0x45, 0x67, 0xc6 ]};

extern(System)

interface nsPIExternalAppLauncher : nsISupports {

  static const char[] IID_STR = NS_PIEXTERNALAPPLAUNCHER_IID_STR;
  static const nsIID IID = NS_PIEXTERNALAPPLAUNCHER_IID;

  nsresult DeleteTemporaryFileOnExit(nsIFile aTemporaryFile);

}

/******************************************************************************

******************************************************************************/

const char[] NS_IHELPERAPPLAUNCHER_IID_STR = "99a0882d-2ff9-4659-9952-9ac531ba5592";

const nsIID NS_IHELPERAPPLAUNCHER_IID= 
  {0x99a0882d, 0x2ff9, 0x4659, 
    [ 0x99, 0x52, 0x9a, 0xc5, 0x31, 0xba, 0x55, 0x92 ]};

extern(System)

interface nsIHelperAppLauncher : nsICancelable {

  static const char[] IID_STR = NS_IHELPERAPPLAUNCHER_IID_STR;
  static const nsIID IID = NS_IHELPERAPPLAUNCHER_IID;

  nsresult GetMIMEInfo(nsIMIMEInfo  *aMIMEInfo);
  nsresult GetSource(nsIURI  *aSource);
  nsresult GetSuggestedFileName(nsAString * aSuggestedFileName);
  nsresult SaveToDisk(nsIFile aNewFileLocation, PRBool aRememberThisPreference);
  nsresult LaunchWithApplication(nsIFile aApplication, PRBool aRememberThisPreference);
  nsresult SetWebProgressListener(nsIWebProgressListener2 aWebProgressListener);
  nsresult CloseProgressWindow();
  nsresult GetTargetFile(nsIFile  *aTargetFile);
  nsresult GetTimeDownloadStarted(PRTime *aTimeDownloadStarted);

}

